package com.kernal.bankcard.camera;

import android.app.Activity;
import android.app.Service;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.ImageFormat;
import android.graphics.PixelFormat;
import android.hardware.Camera;
import android.hardware.Camera.AutoFocusCallback;
import android.hardware.Camera.PictureCallback;
import android.hardware.Camera.ShutterCallback;
import android.media.ToneGenerator;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.os.Vibrator;
import android.text.format.Time;
import android.util.Log;
import android.view.KeyEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.Toast;

import com.kernal.bankcard.BankCardRecogUtils;
import com.kernal.bankcard.utils.AppManager;
import com.kernal.bankcard.utils.CameraSetting;
import com.kernal.utils.Utils;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import kernal.bankcard.android.BankCardAPI;

import static com.kernal.bankcard.utils.Devcode.devCode;

public class ScanCamera extends Activity implements SurfaceHolder.Callback, Camera.PreviewCallback {
	private static final String PATH = Environment.getExternalStorageDirectory().toString() + "/DCIM/Camera/";
	private Camera camera;
	private SurfaceView surfaceView;
	private SurfaceHolder surfaceHolder;
	private ImageButton back;
	private ImageButton flash;
	private ImageButton imbtn_eject;
	private ImageButton imbtn_takepic;
	private ImageView help_word;
	private com.kernal.bankcard.camera.ViewfinderView viewfinder_view;

	private BankCardAPI api;
	private Bitmap bitmap;
	private int preWidth;
	private int preHeight;
	private boolean isROI = false;
	private TimerTask timer;
	private Vibrator mVibrator;
	private ToneGenerator tone;
	private byte[] tackData;
	private String devcode;
	private String filePath = null;

	private BankCardRecogUtils bankCardRecogUtils;
	private boolean isFatty;
	private String sn = "";
	private int left, top, right, bottom;
	private Timer time;
	Camera.Parameters parameters;
	public int srcWidth, srcHeight;
	public int surfaceWidth, surfaceHeight;
	List<Camera.Size> list;
	private boolean isShowBorder = false;
	RelativeLayout.LayoutParams layoutParams;
	private Message msg;
	private boolean first_info = true;
	private int Format = ImageFormat.NV21;
	private int quality = 100;

	private Handler handler = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			super.handleMessage(msg);
			findView();

		}
	};


	static {
		System.loadLibrary("bankcard_reader");
	}

	protected synchronized static native int nativeCheckPackage(
			String packageName);

	protected synchronized static native String nativeGetDevcode();

	private String callerPackageName = "";
	public static final String TAG = "ScanCamera";
	public static final int RECOG_REQUEST_CODE = 1000;


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);// 横屏
		requestWindowFeature(Window.FEATURE_NO_TITLE);// 隐藏标题
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);// 设置全屏
		// getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		// // 屏幕常亮
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON,
				WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		int activity_scan_camera = getResources().getIdentifier("activity_scan_camera", "layout",
				this.getPackageName());
		setContentView(activity_scan_camera);
		bankCardRecogUtils = new BankCardRecogUtils(getApplicationContext());
		// enterLightsOutMode(getWindow());
		CameraSetting.hiddenVirtualButtons(getWindow().getDecorView());
		CameraSetting.setScreenSize(this);
		srcWidth = CameraSetting.srcWidth;
		srcHeight = CameraSetting.srcHeight;
		Intent intent = getIntent();
		//devcode = intent.getStringExtra("devcode");
		callerPackageName = getIntent().getComponent().getPackageName();
		devcode = nativeGetDevcode();
		Log.i(TAG, "devcode="+devCode);
		sn = intent.getStringExtra("sn");
		AppManager.getAppManager().addActivity(ScanCamera.this);

	}

	@Override
	protected void onStart() {
		// TODO Auto-generated method stub
		super.onStart();
		int surfaceViwe = getResources().getIdentifier("surfaceViwe", "id", this.getPackageName());
		surfaceView = (SurfaceView) findViewById(surfaceViwe);
		int help_word_ = getResources().getIdentifier("help_word", "id", this.getPackageName());
		help_word = (ImageView) findViewById(help_word_);
		int back_camera_ = getResources().getIdentifier("back_camera", "id", this.getPackageName());
		back = (ImageButton) findViewById(back_camera_);
		int flash_camera_ = getResources().getIdentifier("flash_camera", "id", this.getPackageName());
		flash = (ImageButton) findViewById(flash_camera_);
		int imbtn_takepic_ = getResources().getIdentifier("imbtn_takepic", "id", this.getPackageName());
		imbtn_takepic = (ImageButton) findViewById(imbtn_takepic_);
		int imbtn_eject_ = getResources().getIdentifier("imbtn_eject", "id", this.getPackageName());
		imbtn_eject = (ImageButton) findViewById(imbtn_eject_);
		int viewfinder_view_ = getResources().getIdentifier("viewfinder_view", "id", this.getPackageName());
		viewfinder_view = (ViewfinderView) findViewById(viewfinder_view_);

		surfaceHolder = surfaceView.getHolder();
		surfaceHolder.addCallback(ScanCamera.this);
		surfaceHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
		
		api = new BankCardAPI();
		api.WTInitCardKernal("", 0);
		System.out.println("核心版本号：" + api.GetKernalVersion());
		
	}

	@Override
	protected void onRestart() {
		
		if (bitmap != null) {
			bitmap.recycle();
			bitmap = null;
		}
		
		counterFail = 0;

		super.onRestart();
	}

	@Override
	protected void onResume() {
		super.onResume();
		startCamera();
		//if (nativeCheckPackage(callerPackageName) != 0) {
		//	Intent intent = new Intent();
		//	intent.putExtra("exception", getString(R.string.packageNameInvalid));
		//	setResult(RECOG_REQUEST_CODE, intent);
		//	finish();
		//}
	}
	
	/**
 * 能够解决小米pad电源键熄屏15秒后，重新打开卡死的现象
 */
	private void startCamera() {
//		System.out.println("相机开启");
		if (camera == null) {
			try {
				camera = Camera.open();
				time = new Timer();
				if (timer == null) {
					timer = new TimerTask() {
						public void run() {
							if (isStopAutoFocus) {// 如果识别成功后不在进行对焦操作
								return;
							}
							if (camera != null) {
								try {
									camera.autoFocus(new AutoFocusCallback() {
										public void onAutoFocus(boolean success, Camera camera) {

										}
									});
								} catch (Exception e) {
									e.printStackTrace();
								}
							}
						};
					};
				}
				time.schedule(timer, 500, 2500);
				if(!first_info){
					initCamera();
				}
			} catch (Exception e) {
				// TODO Auto-generated catch block
				// 禁止使用相机权限后防止布局混乱
				msg = new Message();
				handler.sendMessage(msg);
				Toast.makeText(getApplicationContext(), "相机打开失败！请检查设备拍照权限", Toast.LENGTH_SHORT).show();
			}
			
		}
	}

	private void findView() {

		imbtn_takepic.setVisibility(View.GONE);
		imbtn_eject.setVisibility(View.VISIBLE);
		surfaceWidth = srcWidth;
		surfaceHeight = srcHeight;
		if (srcWidth * 3 == srcHeight * 4) {
			isFatty = true;
		}
		if (srcWidth == surfaceView.getWidth() || surfaceView.getWidth() == 0) {
			layoutParams = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.FILL_PARENT, srcHeight);
			surfaceView.setLayoutParams(layoutParams);

			// 拍照按钮布局
			layoutParams = new RelativeLayout.LayoutParams((int) (srcWidth * 0.1), (int) (srcWidth * 0.1));
			layoutParams.addRule(RelativeLayout.CENTER_VERTICAL);
			layoutParams.leftMargin = (int) (srcWidth * 0.89);
			imbtn_takepic.setLayoutParams(layoutParams);
		}

		else if (srcWidth > surfaceView.getWidth()) {
			// 如果将虚拟硬件弹出则执行如下布局代码，相机预览分辨率不变压缩屏幕的高度
			int surfaceViewHeight = (surfaceView.getWidth() * srcHeight) / srcWidth;
			layoutParams = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.FILL_PARENT, surfaceViewHeight);
			layoutParams.topMargin = (srcHeight - surfaceViewHeight) / 2;
			surfaceView.setLayoutParams(layoutParams);
			// 拍照按钮布局

			layoutParams = new RelativeLayout.LayoutParams((int) (srcWidth * 0.1), (int) (srcWidth * 0.1));
			layoutParams.addRule(RelativeLayout.CENTER_VERTICAL);
			layoutParams.leftMargin = (int) (srcWidth * 0.83);

			imbtn_takepic.setLayoutParams(layoutParams);
		}

		int back_w = (int) (srcWidth * 0.06);
		int back_h = (int) (back_w * 1);
		layoutParams = new RelativeLayout.LayoutParams(back_w, back_h);
		layoutParams.addRule(RelativeLayout.ALIGN_PARENT_LEFT, RelativeLayout.TRUE);
		layoutParams.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM, RelativeLayout.TRUE);
		int Fheight = srcHeight;
		if (isFatty)
			Fheight = (int) (srcHeight * 0.75);
		layoutParams.leftMargin = (int) (((srcWidth - Fheight * 0.8 * 1.585) / 2 - back_h) / 2);
		layoutParams.bottomMargin = (int) (srcHeight * 0.07);
		back.setLayoutParams(layoutParams);

		int flash_w = (int) (srcWidth * 0.06);
		int flash_h = (int) (flash_w * 1);
		layoutParams = new RelativeLayout.LayoutParams(flash_w, flash_h);
		layoutParams.addRule(RelativeLayout.ALIGN_PARENT_LEFT, RelativeLayout.TRUE);
		layoutParams.addRule(RelativeLayout.ALIGN_PARENT_TOP, RelativeLayout.TRUE);
		if (isFatty)
			Fheight = (int) (srcHeight * 0.75);
		layoutParams.leftMargin = (int) (((srcWidth - Fheight * 0.8 * 1.585) / 2 - back_h) / 2);
		layoutParams.topMargin = (int) (srcHeight * 0.07);
		flash.setLayoutParams(layoutParams);

		int help_word_w = (int) (srcWidth * 0.474609375);
		int help_word_h = (int) (help_word_w * 0.05185185185185185185185185185185);
		layoutParams = new RelativeLayout.LayoutParams(help_word_w, help_word_h);
		layoutParams.addRule(RelativeLayout.CENTER_HORIZONTAL, RelativeLayout.TRUE);
		layoutParams.addRule(RelativeLayout.CENTER_VERTICAL, RelativeLayout.TRUE);
		help_word.setLayoutParams(layoutParams);

		int eject_btn_w = (int) (srcWidth * 0.024453125);
		int eject_btn_h = (int) (eject_btn_w * 7.8108108108108108108108108108108);
		layoutParams = new RelativeLayout.LayoutParams(eject_btn_w, eject_btn_h);
		layoutParams.addRule(RelativeLayout.CENTER_VERTICAL, RelativeLayout.TRUE);
		layoutParams.addRule(RelativeLayout.ALIGN_PARENT_RIGHT, RelativeLayout.TRUE);
		imbtn_eject.setLayoutParams(layoutParams);

		if (surfaceWidth < srcWidth || surfaceHeight < srcHeight) {

			System.out.println("surfaceWidth：++" + surfaceWidth + "surfaceHeight:++" + surfaceHeight);
			layoutParams = new RelativeLayout.LayoutParams(surfaceWidth, surfaceHeight);
			layoutParams.addRule(RelativeLayout.CENTER_IN_PARENT);
			surfaceView.setLayoutParams(layoutParams);
			// 拍照按钮布局
			layoutParams = new RelativeLayout.LayoutParams((int) (srcWidth * 0.1), (int) (srcWidth * 0.1));
			layoutParams.addRule(RelativeLayout.CENTER_VERTICAL);
			if (srcWidth == 1280 && srcHeight == 800)
				layoutParams.leftMargin = (int) (srcWidth * 0.85);
			else
				layoutParams.leftMargin = (int) (srcWidth * 0.885);
			imbtn_takepic.setLayoutParams(layoutParams);
		}

		back.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				camera = CameraSetting.closeCamera(camera);
				Intent intent = new Intent();
				setResult(RECOG_REQUEST_CODE, intent);
				ScanCamera.this.finish();

				//Intent intent = new Intent(ScanCamera.this,MainActivity.class);
				//startActivity(intent);
			}
		});
		imbtn_eject.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				imbtn_takepic.setVisibility(View.VISIBLE);
				imbtn_eject.setVisibility(View.GONE);
			}
		});
		flash.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				if (!getPackageManager().hasSystemFeature(PackageManager.FEATURE_CAMERA_FLASH)) {
					Toast.makeText(ScanCamera.this,
							getResources()
									.getString(getResources().getIdentifier("no_flash", "string", getPackageName())),
							Toast.LENGTH_LONG).show();
				} else {
					if (camera != null) {
						String flashMode = parameters.getFlashMode();
						if (flashMode.equals(Camera.Parameters.FLASH_MODE_TORCH)) {
							parameters.setFlashMode(Camera.Parameters.FLASH_MODE_OFF);
							parameters.setExposureCompensation(0);
						} else {
							parameters.setFlashMode(Camera.Parameters.FLASH_MODE_TORCH);// 闪光灯常亮
							parameters.setExposureCompensation(-1);
						}
						try {
							camera.setParameters(parameters);
						} catch (Exception e) {
							Toast.makeText(ScanCamera.this,
									getResources().getString(
											getResources().getIdentifier("no_flash", "string", getPackageName())),
									Toast.LENGTH_LONG).show();
						}
						camera.startPreview();
					}
				}
			}
		});
		imbtn_takepic.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				api.WTUnInitCardKernal();
				if (timer != null) {
					timer.cancel();
					timer = null;
				}
				if (camera != null) {
					try {
						isFocusTakePicture(camera);
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			}
		});

	}

	private ShutterCallback shutterCallback = new ShutterCallback() {
		public void onShutter() {
			try {
				if (tone == null) {
					tone = new ToneGenerator(1, ToneGenerator.MIN_VOLUME);
				}
				tone.startTone(ToneGenerator.TONE_PROP_BEEP);
			} catch (Exception e) {
				e.printStackTrace();
			}

		}
	};
	protected boolean isStopAutoFocus;


	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		initCamera();
	}

	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
			msg = new Message();
			handler.sendMessage(msg);

	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		
		CloseCamera(camera);
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
					
				camera = CameraSetting.closeCamera(camera);
				Intent intent = new Intent();
				setResult(RECOG_REQUEST_CODE, intent);
				ScanCamera.this.finish();

			//Intent intent = new Intent(ScanCamera.this,MainActivity.class);
				//startActivity(intent);
		}
		return super.onKeyDown(keyCode, event);
	}
	
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		first_info = false;
		super.onPause();
		
		if (bitmap != null) {
			bitmap.recycle();
			bitmap = null;
		}
		CloseCamera(camera);
	}
	
	private void CloseCamera(Camera camera2) {
		// TODO Auto-generated method stub
		try {
			if (camera != null) {
				if (time != null) {
					time.cancel();
					time = null;
				}
				if (timer != null) {
					timer.cancel();
					timer = null;
				}
				camera = CameraSetting.closeCamera(camera);;
			}
		} catch (Exception e) {
		}
	}

	

	private void initCamera() {
		if (camera != null) {
			
			CameraSetting.getCameraPreParameters(camera);
			preWidth = CameraSetting.preWidth;
			preHeight = CameraSetting.preHeight;
			parameters = camera.getParameters();
			if (parameters.getSupportedFocusModes().contains(parameters.FOCUS_MODE_AUTO)) {
				parameters.setFocusMode(parameters.FOCUS_MODE_AUTO);
			}
			
			parameters.setPictureFormat(PixelFormat.JPEG);
			parameters.setExposureCompensation(0);
			parameters.setPreviewSize(preWidth/* 1920 */, preHeight/* 1080 */);
			if (!isROI) {
				int l = (int) (preWidth * 0.16);
				int t = (int) (preHeight - 0.41004673 * preWidth) / 2;
				int r = (int) (preWidth * 0.85);
				int b = (int) (preHeight + 0.41004673 * preWidth) / 2;

				if (isFatty) {
					t = srcHeight / 5;
					b = srcHeight - t;
					l = (int) (srcWidth - ((b - t) * 1.585)) / 2;
					r = srcWidth - l;
					double proportion = (double) srcWidth / (double) preWidth;
					l = (int) (l / proportion);
					t = (int) (t / proportion);
					r = (int) (r / proportion);
					b = (int) (b / proportion);
				}
				int borders[] = { l, t, r, b };
				left = l;
				top = t;
				right = r;
				bottom = b;
				api.WTSetROI(borders, preWidth, preHeight);
				isROI = true;
				
			}
			try {
				camera.setPreviewDisplay(surfaceHolder);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			camera.setPreviewCallback(ScanCamera.this);
			camera.setParameters(parameters);
			if ("Nexus 5X".equals(Build.MODEL)) {
				camera.setDisplayOrientation(180);
			}
			camera.startPreview();
		}
	}

	public String savePicture(Bitmap bitmap) {
		String strCaptureFilePath = PATH + "bankcard_" + pictureName() + ".jpg";
		File dir = new File(PATH);
		if (!dir.exists()) {
			dir.mkdirs();
		}
		File file = new File(strCaptureFilePath);
		if (file.exists()) {
			file.delete();
		}
		try {
			file.createNewFile();
			BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(file));

			bitmap.compress(Bitmap.CompressFormat.JPEG, 100, bos);
			bos.flush();
			bos.close();

		} catch (Exception e) {
			e.printStackTrace();
		}

		return strCaptureFilePath;
	}

	public String pictureName() {
		String str = "";
		Time t = new Time();
		t.setToNow(); // 取得系统时间。
		int year = t.year;
		int month = t.month + 1;
		int date = t.monthDay;
		int hour = t.hour; // 0-23
		int minute = t.minute;
		int second = t.second;
		if (month < 10)
			str = String.valueOf(year) + "0" + String.valueOf(month);
		else {
			str = String.valueOf(year) + String.valueOf(month);
		}
		if (date < 10)
			str = str + "0" + String.valueOf(date + "_");
		else {
			str = str + String.valueOf(date + "_");
		}
		if (hour < 10)
			str = str + "0" + String.valueOf(hour);
		else {
			str = str + String.valueOf(hour);
		}
		if (minute < 10)
			str = str + "0" + String.valueOf(minute);
		else {
			str = str + String.valueOf(minute);
		}
		if (second < 10)
			str = str + "0" + String.valueOf(second);
		else {
			str = str + String.valueOf(second);
		}
		return str;
	}

	private PictureCallback picturecallback = new PictureCallback() {
		@Override
		public void onPictureTaken(byte[] data, Camera camera) {
			if (camera != null) {
				camera.setPreviewCallback(null);
			}
			Camera.Parameters parameters = camera.getParameters();

			int pW = parameters.getPreviewSize().width;
			int pH = parameters.getPreviewSize().height;
			if (tackData != null) {

				int[] datas = Utils.convertYUV420_NV21toARGB8888(tackData, pW, pH);

				BitmapFactory.Options opts = new BitmapFactory.Options();
				opts.inInputShareable = true;
				opts.inPurgeable = true;
				bitmap = Bitmap.createBitmap(datas, pW, pH, android.graphics.Bitmap.Config.ARGB_8888);
			}

			if (bitmap != null) {
				int $t = srcHeight / 10;
				int t = $t;
				int b = srcHeight - t;
				int $l = (int) ((b - t) * 1.58577);
				int l = (srcWidth - $l) / 2;
				int r = srcWidth - l;
				double proportion = (double) srcWidth / (double) preWidth;
				l = (int) (l / proportion);
				t = (int) (t / proportion);
				r = (int) (r / proportion);
				b = (int) (b / proportion);
				String path = savePicture(bitmap);
				// camera.stopPreview();
				tackData = null;
				camera.startPreview();
				parameters.setFlashMode(parameters.FLASH_MODE_OFF);
				camera.setParameters(parameters);
				camera.stopPreview();
				//Intent intent = new Intent(ScanCamera.this,ShowResult.class);
				Intent intent = new Intent();
				intent.putExtra("Success", 3);
				intent.putExtra("Path", path);
				intent.putExtra("devcode", devcode);
				intent.putExtra("l", l);
				intent.putExtra("t", t);
				intent.putExtra("w", r - l);
				intent.putExtra("h", b - t);
				//startActivity(intent);
				setResult(RECOG_REQUEST_CODE, intent);
				ScanCamera.this.finish();
			}

		}
	};

	private int counter = 0;
	private int counterFail = 0;
	private int counterCut = 0;

	@Override
	public void onPreviewFrame(byte[] data, Camera camera) {
		String[] results;
		tackData = data;
		Camera.Parameters parameters = camera.getParameters();
		int isBorders[] = { 0, 0, 0, 0 };
		counter++;
		if (counter == 2) {
			counter = 0;
			int bRotated[] = { 0 };
			int pLineWarp[] = new int[32000];
			api.SetFilterInvalidCard(1); // 设置过滤无效卡 -- 1:过滤;0:不过滤
			api.SetExpiryDateFlag(1); // 设置过期日期标志 -- 1：返回日期;0:不返回日期
			results = bankCardRecogUtils.getRecogResult(data, parameters.getPreviewSize().width,
					parameters.getPreviewSize().height, isBorders, bRotated, pLineWarp,
					bankCardRecogUtils.intiDevCode(devcode));
			int r = Integer.valueOf(results[0]);
			if (isBorders[0] == 1) {
				if (viewfinder_view != null) {
					viewfinder_view.setLeftLine(1);
				}
			} else {
				if (viewfinder_view != null) {
					viewfinder_view.setLeftLine(0);
				}
			}
			if (isBorders[1] == 1) {
				if (viewfinder_view != null) {
					viewfinder_view.setTopLine(1);
				}
			} else {
				if (viewfinder_view != null) {
					viewfinder_view.setTopLine(0);
				}
			}
			if (isBorders[2] == 1) {
				if (viewfinder_view != null) {
					viewfinder_view.setRightLine(1);
				}
			} else {
				if (viewfinder_view != null) {
					viewfinder_view.setRightLine(0);
				}
			}
			if (isBorders[3] == 1) {
				if (viewfinder_view != null) {
					viewfinder_view.setBottomLine(1);
				}
			} else {
				if (viewfinder_view != null) {
					viewfinder_view.setBottomLine(0);
				}
			}
			if (isBorders[0] == 1 && isBorders[1] == 1 && isBorders[2] == 1 && isBorders[3] == 1) {
				if (camera != null) {
				}

				if ((results[2] == null || results[2].equals("")) && results[1] != null && !results[1].equals("")) {
					if (r == 0) {
						isStopAutoFocus = true;
						api.WTUnInitCardKernal();
						mVibrator = (Vibrator) getApplication().getSystemService(Service.VIBRATOR_SERVICE);
						mVibrator.vibrate(100);

						/***
						 * 保存到本地,显示全图start,
						 * 开启全图在ShowResult.java中还需要更换显示图片
						 */

//						YuvImage yuvimage = new YuvImage(data, Format, preWidth, preHeight, null);
//						ByteArrayOutputStream baos = new ByteArrayOutputStream();
//						yuvimage.compressToJpeg(new Rect(left, top, right, bottom), quality, baos);
//						byte[] image = baos.toByteArray();
//						BitmapFactory.Options options = new BitmapFactory.Options();
//						Bitmap bitmap = BitmapFactory.decodeByteArray(image, 0, image.length, options);
//						Matrix matrix = new Matrix();
//						int rotate = Integer.valueOf(results[4]).intValue();
//						if (rotate == 0) {
//							matrix.setRotate(0);
//						} else if (rotate == 1) {
//							matrix.setRotate(180);
//						} else if (rotate == 3) {
//							matrix.setRotate(90);
//						} else if (rotate == 4) {
//							matrix.setRotate(270);
//						}
//						Bitmap imageBitmap = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(), bitmap.getHeight(), matrix, true);
//						FileOutputStream outStream;
//						String timeTag = new SimpleDateFormat("yyyyMMddHHmmss")
//								.format(new Date(System.currentTimeMillis()));
//						try {
//							filePath = PATH + "/BankCard_" + timeTag + ".jpg";
//							File file = new File(filePath);
//							outStream = new FileOutputStream(file);
//							imageBitmap.compress(Bitmap.CompressFormat.JPEG, 100, outStream);// 将图片压缩的流里面
//							outStream.write(baos.toByteArray());
//							outStream.close();
//							baos.close();
//						} catch (IOException e) {
//							e.printStackTrace();
//						}
						/**
						 * 保存到本地、显示全图end
						 * 开启全图在ShowResult.java中还需要更换显示图片
						 */

						camera.stopPreview();
						camera.setPreviewCallback(null);
						camera = null;
						//Intent intent = new Intent(ScanCamera.this,ShowResult.class);
						Intent intent = new Intent();
						intent.putExtra("PicFull", filePath);// 银行卡全图图片
						intent.putExtra("PicNum", pLineWarp);// 卡号图片
						intent.putExtra("CardNum", results[1].toString());// 银行卡号{123456789}
						intent.putExtra("CardDate", results[3]);// 信用卡(凸印字类型)有效日期
						intent.putExtra("devcode", devcode);
						intent.putExtra("Success", 2);
						setResult(RECOG_REQUEST_CODE, intent);
						ScanCamera.this.finish();
						//startActivity(intent);

					}
				} else if (results[2] != null && !results[2].equals("")) {
					Toast.makeText(getBaseContext(),
							getResources()
									.getString(getResources().getIdentifier("toast_code", "string", getPackageName()))
									+ results[2],
							Toast.LENGTH_SHORT).show();
				}
//				if (r == 1) {
					// counterFail++;
					// if (counterFail == 7) {
					// api.WTUnInitCardKernal();
					// camera.setPreviewCallback(null);
					// if (timer != null) {
					// timer.cancel();
					// timer = null;
					// }
					// if (camera != null) {
					// try {
					// isFocusTakePicture(camera);
					// } catch (Exception e) {
					// e.printStackTrace();
					// }
					//
					// }
					// }

//				}
			} else {
				counterCut++;
				if (counterCut == 5) {
					counterFail = 0;
					counterCut = 0;
				}
			}
		}
	}


	private void isFocusTakePicture(Camera camera) {
		final Camera.Parameters parameters = camera.getParameters();
		final boolean flashEnable = getPackageManager().hasSystemFeature(PackageManager.FEATURE_CAMERA_FLASH);
		if (flashEnable) {
			parameters.setFlashMode(Camera.Parameters.FLASH_MODE_ON);
		}

		if (!getPackageManager().hasSystemFeature(PackageManager.FEATURE_CAMERA_AUTOFOCUS)) {
			camera.stopPreview();
			camera.startPreview();
			camera.takePicture(shutterCallback, null, picturecallback);
		} else {
			camera.autoFocus(new AutoFocusCallback() {
				public void onAutoFocus(boolean success, Camera camera) {
					if (success) {
						camera.stopPreview();
						camera.startPreview();
						camera.takePicture(shutterCallback, null, picturecallback);
						if (flashEnable) {
							try {
								camera.setParameters(parameters);
							} catch (Exception e) {
								e.printStackTrace();
							}
						}
					}
				}
			});
		}
	}

}
