package com.kernal.smartvision_bankCard;

import java.util.Timer;
import java.util.TimerTask;

import com.kernal.bankcard.BankCardRecogUtils;
import com.kernal.bankcard.camera.ScanCamera;
import com.kernal.bankcard.utils.AppManager;
import com.kernal.bankcard.utils.CheckPermission;
import com.kernal.bankcard.utils.Devcode;
import com.kernal.bankcard.utils.PermissionActivity;
import com.kernal.bankCard_sdk.R;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Build;
import android.os.Bundle;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.RelativeLayout.LayoutParams;
import android.widget.Toast;

public class MainActivity extends Activity implements OnClickListener {
    private static final int CARDTYPE = 0; // 0自动判断卡号类型，1平面卡，2凸印卡类型
    private Button tackPic_btn_main, ActivationProgram;
    public static int DIALOG_ID = -1;
    private String sn = "";
    private AlertDialog dialog;
    private EditText editText;
    private BankCardRecogUtils bankCardRecogUtils;
    private String devcode = Devcode.devCode;
    public static final String[] PERMISSION = new String[] {
			Manifest.permission.WRITE_EXTERNAL_STORAGE,// 写入权限
			Manifest.permission.READ_EXTERNAL_STORAGE, // 读取权限
			Manifest.permission.READ_PHONE_STATE,
			Manifest.permission.CAMERA,
			Manifest.permission.VIBRATE, 
			Manifest.permission.FLASHLIGHT };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        this.requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                WindowManager.LayoutParams.FLAG_FULLSCREEN);// 设置全屏
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setContentView(R.layout.activity_main);
        System.gc();
        findView();
      //需要释放掉相机界面
      	AppManager.getAppManager().finishAllActivity();
    }

    private void findView() {
        DisplayMetrics displayMetrics = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(displayMetrics);
        int width = displayMetrics.widthPixels;
        int height = displayMetrics.heightPixels;
        Log.e("displayMetrics", "width" + width);
        Log.e("displayMetrics", "height" + height);
        ActivationProgram = (Button) findViewById(R.id.ActivationProgram);
        tackPic_btn_main = (Button) findViewById(R.id.tackPic_btn_main);
        RelativeLayout.LayoutParams layoutParams = new RelativeLayout.LayoutParams(
                LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
        layoutParams.addRule(RelativeLayout.CENTER_HORIZONTAL,
                RelativeLayout.TRUE);
        layoutParams.addRule(RelativeLayout.CENTER_VERTICAL,
                RelativeLayout.TRUE);
        tackPic_btn_main.setLayoutParams(layoutParams);
        tackPic_btn_main.setOnClickListener(this);
        layoutParams = new RelativeLayout.LayoutParams(
                LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
        layoutParams.addRule(RelativeLayout.CENTER_HORIZONTAL,
                RelativeLayout.TRUE);
        layoutParams.addRule(RelativeLayout.ABOVE, R.id.tackPic_btn_main);
        ActivationProgram.setLayoutParams(layoutParams);
        ActivationProgram.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        if(v == tackPic_btn_main){
            Intent intentTack = new Intent(this,ScanCamera.class);
            if (Build.VERSION.SDK_INT >= 23) {
				CheckPermission checkPermission = new CheckPermission(this);
				if (checkPermission.permissionSet(PERMISSION)) {
					PermissionActivity.startActivityForResult(this, 0,
							0,devcode, 0,0, PERMISSION);
				} else {
					intentTack.putExtra("devcode", devcode);
		            // intentTack.putExtra("sn", "VR867UPNJDSYLVDYY48EYY5Y5");
		            intentTack.putExtra("CopyrightInfo", "");
		            startActivity(intentTack);
				}
			} else {
				intentTack.putExtra("devcode", devcode);
	            // intentTack.putExtra("sn", "VR867UPNJDSYLVDYY48EYY5Y5");
	            intentTack.putExtra("CopyrightInfo", "");
	            startActivity(intentTack);
			}
            
        }else if(v == ActivationProgram){
            activationProgramOpera();
        }
    }

    // 首先定义一个布尔变量，赋初始值false。然后监听退出按钮，点击退出按钮时，如果该布尔变量值为false，
    // 则把这个变量置为true；如果该变量为true，则退出程序。最后定义一个时间任务，2秒执行一次，如果布尔变量为true，
    // 2秒内没有点击返回键，则置为false。
    // 这样，在点击第一次退出时，仅仅改变布尔值变量，而不会退出，2秒内进行第二次点击才会退出。如果用户点击了一次，
    // 那么2秒之后布尔变量又被置为false，只有2秒内的两次点击才会退出程序。
    private boolean isQuit = false;
    private Timer timer = new Timer();

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {
            if (isQuit == false) {
                isQuit = true;
                Toast.makeText(getBaseContext(), R.string.back_confirm, Toast.LENGTH_SHORT)
                        .show();
                TimerTask task = null;
                task = new TimerTask() {
                    @Override
                    public void run() {
                        isQuit = false;
                    }
                };
                timer.schedule(task, 2000);
            } else {
                finish();
            }
        }
        return true;
    }

    @Override
    protected void onStart() {
        // TODO Auto-generated method stub
        super.onStart();
        bankCardRecogUtils = new BankCardRecogUtils(getApplicationContext());
        // bankCardRecogUtils.startAuthService(sn);
    }

    /**
     * @Title: activationProgramOpera
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @return void 返回类型
     * @throws
     */
    private void activationProgramOpera() {
        // TODO Auto-generated method stub
        DIALOG_ID = 1;
        View view = getLayoutInflater().inflate(R.layout.serialdialog, null);
        editText = (EditText) view.findViewById(R.id.serialdialogEdittext);
        dialog = new AlertDialog.Builder(MainActivity.this)
                .setView(view)
                .setPositiveButton(getString(R.string.online_activation),
                        new DialogInterface.OnClickListener() {

                            public void onClick(DialogInterface dialog,
                                    int which) {
                                InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
                                if (imm.isActive()) {
                                    imm.toggleSoftInput(
                                            InputMethodManager.SHOW_IMPLICIT,
                                            InputMethodManager.HIDE_NOT_ALWAYS);
                                }
                                String editsString = editText.getText()
                                        .toString().toUpperCase();
                                if (editsString != null) {
                                    sn = editsString;
                                }
                                if (isNetworkConnected(MainActivity.this)) {
                                    if (isWifiConnected(MainActivity.this)
                                            || isMobileConnected(MainActivity.this)) {

                                        bankCardRecogUtils.startAuthService(sn);
                                        dialog.dismiss();
                                    } else if (!isWifiConnected(MainActivity.this)
                                            && !isMobileConnected(MainActivity.this)) {
                                        Toast.makeText(
                                                getApplicationContext(),
                                                getString(R.string.network_unused),
                                                Toast.LENGTH_SHORT).show();
                                    }
                                } else {
                                    Toast.makeText(
                                            getApplicationContext(),
                                            getString(R.string.please_connect_network),
                                            Toast.LENGTH_SHORT).show();
                                }

                            }

                        })
                .setNegativeButton(getString(R.string.cancel),
                        new DialogInterface.OnClickListener() {

                            public void onClick(DialogInterface dialog,
                                    int which) {
                                dialog.dismiss();

                            }

                        }).create();
        dialog.show();
    }

    public boolean isNetworkConnected(Context context) {
        if (context != null) {
            ConnectivityManager mConnectivityManager = (ConnectivityManager) context
                    .getSystemService(Context.CONNECTIVITY_SERVICE);
            NetworkInfo mNetworkInfo = mConnectivityManager
                    .getActiveNetworkInfo();
            if (mNetworkInfo != null) {
                return mNetworkInfo.isAvailable();
            }
        }
        return false;
    }

    public boolean isWifiConnected(Context context) {
        if (context != null) {
            ConnectivityManager mConnectivityManager = (ConnectivityManager) context
                    .getSystemService(Context.CONNECTIVITY_SERVICE);
            NetworkInfo mWiFiNetworkInfo = mConnectivityManager
                    .getNetworkInfo(ConnectivityManager.TYPE_WIFI);
            if (mWiFiNetworkInfo != null) {
                return mWiFiNetworkInfo.isAvailable();
            }
        }
        return false;
    }

    public boolean isMobileConnected(Context context) {
        if (context != null) {
            ConnectivityManager mConnectivityManager = (ConnectivityManager) context
                    .getSystemService(Context.CONNECTIVITY_SERVICE);
            NetworkInfo mMobileNetworkInfo = mConnectivityManager
                    .getNetworkInfo(ConnectivityManager.TYPE_MOBILE);
            if (mMobileNetworkInfo != null) {
                return mMobileNetworkInfo.isAvailable();
            }
        }
        return false;
    }
}
